# Author renyupeng
# coding=utf-8
# @Time    : 2021/11/10 3:37 下午
# @Site    : 
# @File    : AppBytedanceVideoReportBusiMonth.py
# @Software: PyCharm
# @contact: renyupeng@c-top.com.cn
# @Tel 1501435553
import logging

from Apietl.conn.TidbConn import TidbConn
from Apietl.utlis.Utils import Utils


class AppBytedanceVideoReportBusiMonth:
    def __init__(self):
        self.conn = TidbConn.get_connection()
        self.parm = Utils.get_task_args()
        self.date_time = self.parm[0]
        self.day_count = Utils.get_days()

    def taskHandler(self):
        try:
            sql_porject = """select account_id from `jeecg-boot`.ctop_user_allocation where media_id=1
group by account_id """
            account_list = TidbConn.quary(self.conn, sql_porject)
            for account_id in account_list:
                try:
                    sql = """SET sql_mode = 'STRICT_TRANS_TABLES,NO_ZERO_IN_DATE,NO_ZERO_DATE,NO_AUTO_CREATE_USER,NO_ENGINE_SUBSTITUTION';
REPLACE INTO application.app_bytedance_video_report_busi_m
SELECT date_format({date_time},'%Y%m')         stat_mon,
       report.account_id,
       #'账户ID'                                                                                                                                                                                                                                                                    
       report.material_id,
       #头条素材id                                                                                                                                                                                                                                
       report.image_mode,
       #素材类型                                                                                                                                                                                                                               
       report.inventory,
       #广告位                                                                                                                                                                                                                                
       cua.project_id,
       #项目id  
       product.id      product_id,
       #项目中产品id
       cua.advertiser_id,
       #广告主id
       uc.company_id,
       #运营人的公司id                      
       cua.auth_name   account_name,
       #账户名称
       cp.project_name,
       #项目名称  
       ca.`name`       advertiser_name,
       #广告主名称
       uc.company_name,
       #运营人的公司名称
       cp.sale_id,
       #项目里的销售id
       cua.user_id,
       #运营id                                                                                                          
       cma.clip_id,
       #剪辑id
       cma.shot_id,
       #拍摄id
       cma.plan_id,
       #编导id
       cma.leader_id,
       #负责人id
       su.org_code,
       #机构编码
       video.signature,
       #素材id  
       NULL            chl_type,
       #渠道类型
       clip.realname   clip_name,
       #剪辑名称
       shot.realname   shot_name,
       #拍摄名称
       plan.realname   plan_name,
       #编导名称
       leader.realname lead_name,
       #负责人名称
       CASE
           WHEN cmi.material_name IS NOT NULL THEN
               cmi.material_name
           ELSE
               video.filename
           END AS      video_name,
       ##视频名称
       NULL            chl_name,
       #渠道名称
       up.company_id   clip_company_id,
       #剪辑公司
       report.cost,
       report.`show`,
       report.avg_show_cost,
       report.click,
       report.avg_click_cost,
       report.ctr,
       report.`convert`,
       report.convert_cost,
       report.convert_rate,
       report.deep_convert,
       report.deep_convert_cost,
       report.deep_convert_rate,
       report.attribution_convert,
       report.attribution_convert_cost,
       report.attribution_deep_convert,
       report.attribution_deep_convert_cost,
       report.download_start,
       report.download_start_cost,
       report.download_start_rate,
       report.download_finish,
       report.download_finish_cost,
       report.download_finish_rate,
       report.click_install,
       report.install_finish,
       report.install_finish_cost,
       report.install_finish_rate,
       report.active,
       report.active_cost,
       report.active_rate,
       report.register,
       report.active_register_cost,
       report.active_register_rate,
       report.active_pay_amount,
       report.next_day_open,
       report.next_day_open_cost,
       report.next_day_open_rate,
       report.attribution_next_day_open_cnt,
       report.attribution_next_day_open_cost,
       report.attribution_next_day_open_rate,
       report.game_addiction,
       report.game_addiction_cost,
       report.game_addiction_rate,
       report.pay_count,
       report.active_pay_cost,
       report.active_pay_rate,
       report.loan_completion,
       report.loan_completion_cost,
       report.loan_completion_rate,
       report.pre_loan_credit,
       report.pre_loan_credit_cost,
       report.loan_credit,
       report.loan_credit_cost,
       report.loan_credit_rate,
       report.in_app_uv,
       report.in_app_detail_uv,
       report.in_app_cart,
       report.in_app_pay,
       report.in_app_order,
       report.attribution_game_pay_7d_count,
       report.attribution_game_pay_7d_cost,
       report.attribution_active_pay_7d_per_count,
       report.game_pay_cost,
       report.game_pay_count,
       report.phone,
       report.form,
       report.map_search,
       report.button,
       report.`view`,
       report.download,
       report.qq,
       report.lottery,
       report.vote,
       report.message,
       report.redirect,
       report.shopping,
       report.consult,
       report.wechat,
       report.phone_confirm,
       report.phone_connect,
       report.consult_effective,
       report.coupon,
       report.coupon_single_page,
       report.redirect_to_shop,
       report.poi_collect,
       report.poi_address_click,
       report.luban_order_cnt,
       report.luban_order_stat_amount,
       report.luban_order_roi,
       report.luban_live_enter_cnt,
       report.live_watch_one_minute_count,
       report.luban_live_follow_cnt,
       report.live_fans_club_join_cnt,
       report.luban_live_comment_cnt,
       report.luban_live_share_cnt,
       report.luban_live_gift_cnt,
       report.luban_live_gift_amount,
       report.luban_live_slidecart_click_cnt,
       report.luban_live_click_product_cnt,
       report.luban_live_pay_order_count,
       report.luban_live_pay_order_stat_cost,
       report.wechat_login_count,
       report.attribution_wechat_login_30d_count,
       report.wechat_login_cost,
       report.attribution_wechat_login_30d_cost,
       report.wechat_first_pay_count,
       report.attribution_wechat_first_pay_30d_count,
       report.wechat_first_pay_cost,
       report.attribution_wechat_first_pay_30d_cost,
       report.wechat_first_pay_rate,
       report.attribution_wechat_first_pay_30d_rate,
       report.wechat_pay_amount,
       report.attribution_wechat_pay_30d_amount,
       report.attribution_wechat_pay_30d_roi,
       report.phone_effective,
       report.total_play,
       report.valid_play,
       report.valid_play_cost,
       report.valid_play_rate,
       report.play_25_feed_break,
       report.play_50_feed_break,
       report.play_75_feed_break,
       report.play_100_feed_break,
       report.average_play_time_per_play,
       report.play_over_rate,
       report.wifi_play_rate,
       report.wifi_play,
       report.play_duration_sum,
       report.advanced_creative_phone_click,
       report.advanced_creative_counsel_click,
       report.advanced_creative_form_click,
       report.advanced_creative_coupon_addition,
       report.advanced_creative_form_submit,
       report.card_show,
       report.`share`,
       report.`comment`,
       report.`like`,
       report.follow,
       report.home_visited,
       report.ies_challenge_click,
       report.ies_music_click,
       report.location_click,
       report.message_action,
       report.click_landing_page,
       report.click_shopwindow,
       report.click_website,
       report.click_download,
       report.click_call_dy,
       report.`cpc`,
       report.`cpm`,
       report.`cpa`,
       report.`interact_per_cost`,
       report.`convert_show_rate`,
       report.`play_duration_10s_rate`,
       report.`play_50_feed_break_rate`,
       report.`play_25_feed_break_rate`,
       report.`play_duration_5s_rate`,
       report.`play_duration_2s_rate`,
       report.`average_play_progress`,
       report.`play_100_feed_break_rate`,
       report.`play_duration_3s_rate`,
       report.`play_75_feed_break_rate`,
       report.`play_duration`,
       report.`play_duration_3s`,
       report.`play_duration_2s`,
       report.`play_duration_10s`,
       report.`average_video_play`,
       report.`avg_rank`,
       report.submit_certification_count,
       report.approval_count,
       report.first_rental_order_count,
       report.first_order_count,
       report.commute_first_pay_count,
       video.`video_url`,
       cmi.`cover_url`
FROM (
          SELECT advertiser_id    account_id,
                material_id,
                image_mode,
                inventory,
          sum(cost) cost,
          sum(`show`) `show`,
          ifnull(round(sum(cost) / sum(`show`), 3),0) avg_show_cost,
          sum(click) click,
          ifnull(round(sum(cost) / sum(`click`), 3),0) avg_click_cost,
          ifnull(round(sum(click) / sum(`show`) * 100,3),0) ctr,
          sum(`convert`) `convert`,
          ifnull(round(sum(cost) / sum(`convert`), 3),0) convert_cost,
          ifnull(round(sum(`convert`) / sum(click) * 100,3),0) convert_rate,
          sum(deep_convert) deep_convert,
          ifnull(round(sum(cost) / sum(deep_convert),3),0) deep_convert_cost,
          ifnull(round(sum(deep_convert) / sum(`convert`) * 100,3),0) deep_convert_rate,
          sum(attribution_convert) attribution_convert,
          ifnull(round(sum(cost) / sum(attribution_convert),3),0) attribution_convert_cost,
          sum(attribution_deep_convert) attribution_deep_convert,
          ifnull(round(sum(cost) / sum(attribution_deep_convert),3),0) attribution_deep_convert_cost,
          sum(download_start) download_start,
          ifnull(round(sum(cost) / sum(download_start),3),0) download_start_cost,
          ifnull(round(sum(download_start) / sum(click),3),0) download_start_rate,
          sum(download_finish) download_finish,
          ifnull(round(sum(cost) / sum(download_finish),3),0) download_finish_cost,
          ifnull(round(sum(download_finish) / sum(download_start) * 100,3),0) download_finish_rate,
          sum(click_install) click_install,
          sum(install_finish) install_finish,
          ifnull(round(sum(cost) / sum(install_finish),3),0) install_finish_cost,
          ifnull(round(sum(install_finish) / sum(download_finish) * 100,3),0) install_finish_rate,
          sum(active) active,
          ifnull(round(sum(cost) / sum(active), 3),0) active_cost,
          ifnull(round(sum(active) / sum(click) * 100,3),0) active_rate,
          sum(register) register,
          ifnull(round(sum(cost) / sum(register), 3),0) active_register_cost,
          ifnull(round(sum(active_register_rate) /{day_count} * 100,3),0) active_register_rate,
          sum(active_pay_amount) active_pay_amount,
          sum(next_day_open) next_day_open,
          ifnull(round(sum(cost) / sum(next_day_open),3),0) next_day_open_cost,
          ifnull(round(sum(next_day_open) / sum(active) * 100,3),0) next_day_open_rate,
          sum(attribution_next_day_open_cnt) attribution_next_day_open_cnt,
          ifnull(round(sum(cost) / sum(	attribution_next_day_open_cnt),3),0) attribution_next_day_open_cost,
          ifnull(round(sum(	attribution_next_day_open_cnt) / sum(active) * 100,3),0) attribution_next_day_open_rate,
          sum(game_addiction) game_addiction,
          ifnull(round(sum(cost) / sum(game_addiction),3),0) game_addiction_cost,
          ifnull(round(sum(game_addiction_rate) /{day_count} * 100,3),0) game_addiction_rate,
          sum(pay_count) pay_count,
          ifnull(round(sum(cost) / sum(pay_count), 3),0) active_pay_cost,
          ifnull(round(sum(pay_count) / sum(active) * 100,3),0) active_pay_rate,
          sum(loan_completion) loan_completion,
          ifnull(round(sum(cost) / sum(loan_completion),3),0) loan_completion_cost,
          ifnull(round(sum(loan_completion) / sum(register) * 100,3),0) loan_completion_rate,
          ifnull(round(sum(pre_loan_credit), 3),0) pre_loan_credit,
          ifnull(round(sum(cost) / sum(pre_loan_credit),3),0) pre_loan_credit_cost,
          sum(loan_credit) loan_credit,
          ifnull(round(sum(cost) / sum(loan_credit),3),0) loan_credit_cost,
          ifnull(round(sum(loan_credit) / sum(loan_completion) * 100,3),0) loan_credit_rate,
          sum(in_app_uv) in_app_uv,
          sum(in_app_detail_uv) in_app_detail_uv,
          sum(in_app_cart) in_app_cart,
          sum(in_app_pay) in_app_pay,
          sum(in_app_order) in_app_order,
          ifnull(round(sum(	attribution_game_pay_7d_count) /{day_count}, 3),0) attribution_game_pay_7d_count,
          ifnull(round(sum(	attribution_game_pay_7d_cost) /{day_count}, 3),0) attribution_game_pay_7d_cost,
          ifnull(round(sum(	attribution_active_pay_7d_per_count) /{day_count}, 3),0) attribution_active_pay_7d_per_count,
          sum(game_pay_cost) game_pay_cost,
          sum(game_pay_count) game_pay_count,
          sum(phone) phone,
          sum(form) form,
          sum(map_search) map_search,
          sum(button) button,
          sum(`view`) `view`,
          sum(download) download,
          sum(qq) qq,
          sum(lottery) lottery,
          sum(vote) vote,
          sum(message) message,
          sum(redirect) redirect,
          sum(shopping) shopping,
          sum(consult) consult,
          sum(wechat) wechat,
          sum(phone_confirm) phone_confirm,
          sum(phone_connect) phone_connect,
          sum(consult_effective) consult_effective,
          sum(coupon) coupon,
          sum(coupon_single_page) coupon_single_page,
          sum(redirect_to_shop) redirect_to_shop,
          sum(poi_collect) poi_collect,
          sum(poi_address_click) poi_address_click,
          sum(luban_order_cnt) luban_order_cnt,
          sum(luban_order_stat_amount) luban_order_stat_amount,
          sum(luban_order_roi) luban_order_roi,
          sum(luban_live_enter_cnt) luban_live_enter_cnt,
          sum(live_watch_one_minute_count) live_watch_one_minute_count,
          sum(luban_live_follow_cnt) luban_live_follow_cnt,
          sum(live_fans_club_join_cnt) live_fans_club_join_cnt,
          sum(luban_live_comment_cnt) luban_live_comment_cnt,
          sum(luban_live_share_cnt) luban_live_share_cnt,
          sum(luban_live_gift_cnt) luban_live_gift_cnt,
          sum(luban_live_gift_amount) luban_live_gift_amount,
          sum(luban_live_slidecart_click_cnt) luban_live_slidecart_click_cnt,
          sum(luban_live_click_product_cnt) luban_live_click_product_cnt,
          sum(luban_live_pay_order_count) luban_live_pay_order_count,
          sum(luban_live_pay_order_stat_cost) luban_live_pay_order_stat_cost,
          sum(wechat_login_count) wechat_login_count,
          sum(attribution_wechat_login_30d_count) attribution_wechat_login_30d_count,
          ifnull(round(sum(cost) / sum(wechat_login_count),3),0) wechat_login_cost,
          ifnull(round(sum(cost) / sum(	attribution_wechat_login_30d_count),3),0) attribution_wechat_login_30d_cost,
          sum(wechat_first_pay_count) wechat_first_pay_count,
          sum(attribution_wechat_first_pay_30d_count) attribution_wechat_first_pay_30d_count,
          ifnull(round(sum(cost) / sum(wechat_first_pay_count),3),0) wechat_first_pay_cost,
          ifnull(round(sum(cost) / sum(	attribution_wechat_first_pay_30d_count),3),0) attribution_wechat_first_pay_30d_cost,
          ifnull(round(sum(wechat_first_pay_count) / sum(wechat_login_count) * 100,3),0) wechat_first_pay_rate,
          ifnull(round(sum(	attribution_wechat_first_pay_30d_count) / sum(	attribution_wechat_login_30d_count) * 100,3),0) attribution_wechat_first_pay_30d_rate,
          sum(wechat_pay_amount) wechat_pay_amount,
          sum(attribution_wechat_pay_30d_amount) attribution_wechat_pay_30d_amount,
          sum(attribution_wechat_pay_30d_roi) attribution_wechat_pay_30d_roi,
          sum(phone_effective) phone_effective,
          sum(total_play) total_play,
          sum(valid_play) valid_play,
          ifnull(round(sum(cost) / sum(valid_play),3),0) valid_play_cost,
          ifnull(round(sum(valid_play) / sum(`show`) * 100,3),0) valid_play_rate,
          sum(play_25_feed_break) play_25_feed_break,
          sum(play_50_feed_break) play_50_feed_break,
          sum(play_75_feed_break) play_75_feed_break,
          sum(play_100_feed_break) play_100_feed_break,
          ifnull(round(sum(average_play_time_per_play) /{day_count}, 3),0) average_play_time_per_play,
          ifnull(round(sum(play_over_rate) /{day_count} * 100,3),0) play_over_rate,
          ifnull(round(sum(wifi_play) / sum(total_play) * 100,3),0) wifi_play_rate,
          sum(wifi_play) wifi_play,
          ifnull(round(sum(play_duration_sum) /{day_count}, 3),0) play_duration_sum,
          sum(advanced_creative_phone_click) advanced_creative_phone_click,
          sum(advanced_creative_counsel_click) advanced_creative_counsel_click,
          sum(advanced_creative_form_click) advanced_creative_form_click,
          sum(advanced_creative_coupon_addition) advanced_creative_coupon_addition,
          sum(advanced_creative_form_submit) advanced_creative_form_submit,
          sum(card_show) card_show,
          sum(`share`) `share`,
          sum(`comment`) `comment`,
          sum(`like`) `like`,
          sum(follow) follow,
          sum(home_visited) home_visited,
          sum(ies_challenge_click) ies_challenge_click,
          sum(ies_music_click) ies_music_click,
          sum(location_click) location_click,
          sum(message_action) message_action,
          sum(click_landing_page) click_landing_page,
          sum(click_shopwindow) click_shopwindow,
          sum(click_website) click_website,
          sum(click_download) click_download,
          sum(click_call_dy) click_call_dy,
          sum(cpc) cpc,
          sum(cpm) cpm,
          sum(cpa) cpa,
          ifnull(round(sum(interact_per_cost) /{day_count}, 3),0) interact_per_cost,
          ifnull(round(sum(convert_show_rate) /{day_count}, 3),0) convert_show_rate,
          ifnull(round(sum(play_duration_10s) / sum(total_play) * 100,3),0) play_duration_10s_rate,
          ifnull(round(sum(play_50_feed_break) / sum(total_play) * 100,3),0) play_50_feed_break_rate,
          ifnull(round(sum(play_25_feed_break) / sum(total_play) * 100,3),0) play_25_feed_break_rate,
          ifnull(round(sum(play_duration_5s_rate) /{day_count}, 3),0) play_duration_5s_rate,
          ifnull(round(sum(play_duration_2s) / sum(total_play) * 100,3),0) play_duration_2s_rate,
          ifnull(round(sum(average_play_progress) /{day_count}, 3),0) average_play_progress,
          ifnull(round(sum(play_100_feed_break) / sum(total_play) * 100,3),0) play_100_feed_break_rate,
          ifnull(round(sum(play_duration_3s) / sum(total_play) * 100,3),0) play_duration_3s_rate,
          ifnull(round(sum(play_75_feed_break) / sum(total_play) * 100,3),0) play_75_feed_break_rate,
          sum(play_duration) play_duration,
          sum(play_duration_3s) play_duration_3s,
          sum(play_duration_2s) play_duration_2s,
          sum(play_duration_10s) play_duration_10s,
          ifnull(round(sum(average_video_play) /{day_count}, 3),0) average_video_play,
          sum(avg_rank) avg_rank,
          sum(submit_certification_count) submit_certification_count,
          sum(approval_count) approval_count,
          sum(first_order_count) first_rental_order_count,
          sum(first_rental_order_count) first_order_count,
          sum(commute_first_pay_count) commute_first_pay_count
         FROM media_api.bytedance_material_report_daily zhubiao
         WHERE image_mode IN (
                              'CREATIVE_IMAGE_MODE_VIDEO',
                              'CREATIVE_IMAGE_MODE_VIDEO_VERTICAL',
                              'CREATIVE_IMAGE_MODE_UNION_SPLASH_VIDEO'
             )
           AND stat_datetime >= date_format(
                 date_sub({date_time}, INTERVAL {day_count}  DAY),
                 '%Y%m%d'
             )
             and advertiser_id={account_id}
         GROUP BY advertiser_id,
                  material_id,
                  image_mode,
                  inventory
     ) report
         LEFT JOIN (select advertiser_id, signature, material_id, filename, video_url
                    from `media_api`.bytedance_file_video_get where advertiser_id={account_id}
                    group by advertiser_id, signature, material_id, filename, video_url) video
                   ON report.account_id = video.advertiser_id AND report.material_id = video.material_id
         LEFT JOIN (select  code,material_name from `jeecg-boot`.ctop_material_info where status=1) cmi 
          ON video.signature = cmi.code
         LEFT JOIN (select material_id, clip_id, shot_id, plan_id, leader_id
                    from (
                             select material_id,
                                    clip_id,
                                    shot_id,
                                    plan_id,
                                    leader_id,
                                    row_number() over (partition by material_id order by create_time) rn
                             from `jeecg-boot`.ctop_material_ascription) m
                    where rn = 1) cma
                   ON video.signature = cma.material_id
         LEFT JOIN `jeecg-boot`.ctop_user_allocation cua ON report.account_id = cua.account_id
         LEFT JOIN `jeecg-boot`.ctop_advertiser ca ON cua.advertiser_id = ca.id
         LEFT JOIN `jeecg-boot`.ctop_project cp ON cua.project_id = cp.id
         LEFT JOIN `jeecg-boot`.user_company uc ON cua.user_id = uc.user_id
         LEFT JOIN `jeecg-boot`.ctop_product product ON cp.product_id = product.id
         LEFT JOIN `jeecg-boot`.sys_user su ON cua.user_id = su.id
         LEFT JOIN `jeecg-boot`.sys_user clip ON clip.id = cma.clip_id
         LEFT JOIN `jeecg-boot`.sys_user shot ON shot.id = cma.shot_id
         LEFT JOIN `jeecg-boot`.sys_user plan ON plan.id = cma.plan_id
         LEFT JOIN `jeecg-boot`.sys_user leader ON leader.id = cma.leader_id
         LEFT JOIN `jeecg-boot`.user_company up ON up.user_id = cma.clip_id
         where cua.account_id = {account_id};""".format(date_time=self.date_time,
                                                        day_count=self.day_count,
                                                        account_id=account_id[0])
                    print(sql)
                    TidbConn.upsert(conn=self.conn, sql_buff=sql)
                    self.conn.commit()
                except Exception as e:
                    logging.error(e)
                    return -1
            TidbConn.conn_close(conn=self.conn)
            return 0
        except Exception as e:
            logging.error(e)
            return -1


if __name__ == '__main__':
    status = AppBytedanceVideoReportBusiMonth().taskHandler()
    if status == 0:
        print("作业执行成功")
        exit(0)
    else:
        print("作业执行失败")
        exit(-1)
