# Author renyupeng
# coding=utf-8
# @Time    : 2021/11/10 3:37 下午
# @Site    :
# @File    : AppKuaishouCompanyUserReportBusi.py
# @Software: PyCharm
# @contact: renyupeng@c-top.com.cn
# @Tel 1501435553
import logging
from Apietl.conn.TidbConn import TidbConn
from Apietl.utlis.Utils import Utils


class AppKuaishouCompanyUserReportBusi:
    def __init__(self):
        self.conn = TidbConn.get_connection()
        self.parm = Utils.get_task_args()
        self.date_time = self.parm[0]
        self.day_count = self.parm[1]

    def taskHandler(self):
        try:
            sql = """
SET sql_mode = 'STRICT_TRANS_TABLES,NO_ZERO_IN_DATE,NO_ZERO_DATE,NO_AUTO_CREATE_USER,NO_ENGINE_SUBSTITUTION';
REPLACE INTO application.app_kuaishou_company_user_report_busi_{day_count}d
select
new.start_end_time,
new.company_id,
new.company_name,
new.org_code,
new.org_type,
new.dep_id,
new.dep_name,
new.leader_id,
new.leader_name,
new.account_num,
new.charge,
ifnull(ratio.charge,0) last_charge,
ifnull(round((new.charge-ratio.charge)/ratio.charge*100,3),0) charge_ratio,
new.show,
new.photo_click,
new.aclick,
new.bclick,
new.photo_click_ratio,
new.play_3s_ratio,
new.action_ratio,
new.impression_1k_cost,
new.photo_click_cost,
new.action_cost,
new.share,
new.comment,
new.like,
new.follow,
new.cancel_follow,
new.report,
new.block,
new.negative,
new.submit,
new.download_started,
new.download_completed,
new.activation,
new.event_pay_first_day,
new.event_pay_purchase_amount_first_day,
new.event_pay_first_day_roi,
new.event_pay,
new.event_pay_purchase_amount,
new.event_pay_roi,
new.event_register,
new.event_register_cost,
new.event_register_ratio,
new.event_jin_jian_app,
new.event_jin_jian_app_cost,
new.event_credit_grant_app,
new.event_credit_grant_app_cost,
new.event_credit_grant_app_ratio,
new.event_order_paid,
new.event_order_paid_purchase_amount,
new.event_order_paid_cost,
new.event_next_day_stay,
new.event_next_day_stay_cost,
new.event_next_day_stay_ratio,
new.form_count,
new.form_cost,
new.form_action_ratio,
new.event_jin_jian_landing_page,
new.event_jin_jian_landing_page_cost,
new.event_credit_grant_landing_page,
new.event_credit_grant_landing_page_cost,
new.event_credit_grant_landing_page_ratio,
new.event_valid_clues,
new.event_valid_clues_cost,
new.event_add_wechat,
new.event_add_wechat_cost,
new.event_add_wechat_ratio,
new.event_get_through,
new.event_get_through_cost,
new.event_get_through_ratio,
new.event_app_invoked,
new.event_app_invoked_cost,
new.event_app_invoked_ratio,
new.event_credit_grant_landing_ratio,
new.play_5s_ratio,
new.play_end_ratio,
new.event_new_user_pay,
new.event_new_user_pay_cost,
new.event_new_user_pay_ratio,
new.click_1k_cost,
new.ad_product_cnt,
new.event_goods_view,
new.merchant_reco_fans,
new.event_order_amount_roi,
new.event_goods_view_cost,
new.merchant_reco_fans_cost,
new.event_button_click,
new.event_button_click_cost,
new.event_button_click_ratio,
new.event_order_paid_roi,
new.event_new_user_jinjian_app,
new.event_new_user_jinjian_app_cost,
new.event_new_user_jinjian_app_roi,
new.event_new_user_credit_grant_app,
new.event_new_user_credit_grant_app_cost,
new.event_new_user_credit_grant_app_roi,
new.event_new_user_jinjian_page,
new.event_new_user_jinjian_page_cost,
new.event_new_user_jinjian_page_roi,
new.event_new_user_credit_grant_page,
new.event_new_user_credit_grant_page_cost,
new.event_new_user_credit_grant_page_roi,
new.event_appoint_form,
new.event_appoint_form_cost,
new.event_appoint_form_ratio,
new.event_appoint_jump_click,
new.event_appoint_jump_click_cost,
new.event_appoint_jump_click_ratio,
new.union_event_pay_purchase_amount_7d,
new.union_event_pay_purchase_amount_7d_roi,
new.event_order_successed,
new.ad_photo_played_10s_ratio,
new.key_action_cost,
new.event_add_shopping_cart_cost,
new.event_ad_watch_times_ratio,
new.event_outbound_call_cost,
new.event_outbound_call,
new.action_new_ratio,
new.event_watch_app_ad,
new.event_multi_conversion_cost,
new.event_phone_card_activate,
new.ad_photo_played_75percent_ratio,
new.key_action_ratio,
new.event_ad_watch_times_cost,
new.event_add_shopping_cart,
new.key_action,
new.event_multi_conversion,
new.event_wechat_connected,
new.event_dsp_gift_form,
new.event_intention_confirmed,
new.event_phone_get_through,
new.event_multi_conversion_ratio,
new.event_measurement_house,
new.ad_photo_played_2s_ratio,
new.event_outbound_call_ratio,
new.event_ad_watch_times
from
(SELECT
concat(date_format(date_sub({date_time}, INTERVAL {day_count}-1 DAY),'%Y%m%d'),'-',{date_time}) start_end_time,
company_id,
company_name,
org_code,
org_type,
dep_id,
dep_name,
leader_id,
trim(leader_name) leader_name,
count(DISTINCT account_id) account_num,
sum(charge) charge,
sum(`show`) `show`,
  sum(photo_click)photo_click,
  sum(aclick)  aclick,
  sum(bclick) bclick,
  round(sum(photo_click)/sum(`show`),3) photo_click_ratio,
  round(sum(play_3s_ratio)/{day_count}*100,3)  play_3s_ratio,
  round(sum(bclick)/sum(aclick)*100,3) action_ratio,
  round(sum(impression_1k_cost)/{day_count},3) impression_1k_cost,
  round(sum(charge)/sum(photo_click),3) photo_click_cost,
  round(sum(charge)/sum(bclick),3) action_cost,
  sum(`share`) `share`,
  sum(`comment`) `comment`,
  sum(`like`)  `like`,
  sum(follow) follow,
  sum(cancel_follow)  cancel_follow,
  sum(report) report,
  sum(block) block,
  sum(negative) negative,
  sum(submit) submit,
  sum(download_started) download_started,
  sum(download_completed) download_completed,
  sum(activation) activation,
  sum(event_pay_first_day) event_pay_first_day,
  sum(event_pay_purchase_amount_first_day) event_pay_purchase_amount_first_day,
  round(sum(event_pay_purchase_amount_first_day)/sum(charge)*100,3) event_pay_first_day_roi ,
  sum(event_pay) event_pay,
  sum(event_pay_purchase_amount) event_pay_purchase_amount,
  round(sum(event_pay_purchase_amount)/sum(charge)*100,3) event_pay_roi,
  sum(event_register) event_register,
  round(sum(charge)/sum(event_register),3) event_register_cost,
  round(sum(event_register)/sum(activation)*100,3) event_register_ratio,
  sum(event_jin_jian_app) event_jin_jian_app,
  round(sum(charge)/sum(event_jin_jian_app),3) event_jin_jian_app_cost,
  sum(event_credit_grant_app) event_credit_grant_app,
  round(sum(charge)/sum(event_credit_grant_app),3) event_credit_grant_app_cost ,
  round(sum(event_credit_grant_app_ratio)/{day_count}*100,3) event_credit_grant_app_ratio,
  sum(event_order_paid) event_order_paid,
  sum(event_order_paid_purchase_amount) event_order_paid_purchase_amount,
  round(sum(event_order_paid_purchase_amount)/sum(event_order_paid) ,3) event_order_paid_cost,
  sum(event_next_day_stay) event_next_day_stay,
  round(sum(charge)/sum(event_next_day_stay),3) event_next_day_stay_cost,
  round(sum(event_next_day_stay)/sum(activation)*100,3) event_next_day_stay_ratio,
  sum(form_count) form_count,
  round(sum(charge)/sum(form_count),3) form_cost,
  round(sum(form_count)/sum(`bclick`)*100,3) form_action_ratio,
  sum(event_jin_jian_landing_page) event_jin_jian_landing_page,
  round(sum(charge)/sum(event_jin_jian_landing_page),3) event_jin_jian_landing_page_cost,
  sum(event_credit_grant_landing_page) event_credit_grant_landing_page,
  round(sum(charge)/sum(event_credit_grant_landing_page),3) event_credit_grant_landing_page_cost,
  round(sum(event_credit_grant_landing_page)/{day_count}*100,3) event_credit_grant_landing_page_ratio,
  sum(event_valid_clues) event_valid_clues,
  round(sum(charge)/sum(event_valid_clues),3) event_valid_clues_cost,
  sum(event_add_wechat) event_add_wechat,
  round(sum(charge)/sum(event_add_wechat),3) event_add_wechat_cost,
  round(sum(event_add_wechat)/sum(bclick)*100,3) event_add_wechat_ratio,
  sum(event_get_through) event_get_through,
  round(sum(charge)/sum(event_get_through),3) event_get_through_cost,
  round(sum(event_get_through)/sum(bclick)*100,3) event_get_through_ratio,
  sum(event_app_invoked) event_app_invoked,
  round(sum(charge)/sum(event_app_invoked),3) event_app_invoked_cost ,
  round(sum(event_app_invoked)/sum(bclick)*100,3) event_app_invoked_ratio,
  round(sum(event_credit_grant_landing_ratio)/{day_count}*100,3) event_credit_grant_landing_ratio,
  round(sum(play_5s_ratio)/{day_count}*100,3) play_5s_ratio,
  round(sum(play_end_ratio)/{day_count}*100,3) play_end_ratio,
  sum(event_new_user_pay) event_new_user_pay,
  round(sum(charge)/sum(event_new_user_pay),3) event_new_user_pay_cost,
  round(sum(event_new_user_pay)/sum(activation)*100,3) event_new_user_pay_ratio,
  round(sum(click_1k_cost)/{day_count}*100) click_1k_cost,
  sum(ad_product_cnt) ad_product_cnt,
  sum(event_goods_view) event_goods_view,
  sum(merchant_reco_fans) merchant_reco_fans,
  round(sum(event_order_amount_roi)/{day_count}*100,3) event_order_amount_roi,
  round(sum(charge)/sum(event_goods_view) ,3) event_goods_view_cost,
  round(sum(charge)/sum(merchant_reco_fans),3) merchant_reco_fans_cost,
  sum(event_button_click) event_button_click,
  round(sum(charge)/sum(event_button_click),3) event_button_click_cost,
  round(sum(event_button_click)/sum(bclick)*100,3) event_button_click_ratio ,
  round(sum(event_order_paid_roi)/{day_count}*100,3) event_order_paid_roi,
  sum(event_new_user_jinjian_app) event_new_user_jinjian_app,
  round(sum(charge)/sum(event_new_user_jinjian_app),3) event_new_user_jinjian_app_cost,
  round(sum(event_new_user_jinjian_app)/sum(form_count)*100,3) event_new_user_jinjian_app_roi ,
  sum(event_new_user_credit_grant_app) event_new_user_credit_grant_app,
  round(sum(charge)/sum(event_new_user_credit_grant_app),3)  event_new_user_credit_grant_app_cost,
  round(sum(event_new_user_credit_grant_app)/sum(form_count)*100,3) event_new_user_credit_grant_app_roi,
  sum(event_new_user_jinjian_page) event_new_user_jinjian_page,
  round(sum(charge)/sum(event_new_user_jinjian_page),3) event_new_user_jinjian_page_cost,
  round(sum(event_new_user_jinjian_page)/sum(form_count)*100,3) event_new_user_jinjian_page_roi ,
  sum(event_new_user_credit_grant_page) event_new_user_credit_grant_page,
  round(sum(charge)/sum(event_new_user_credit_grant_page) ,3) event_new_user_credit_grant_page_cost,
  round(sum(event_new_user_credit_grant_page)/sum(form_count)*100,3) event_new_user_credit_grant_page_roi,
  sum(event_appoint_form)  event_appoint_form,
  round(sum(charge)/sum(event_appoint_form),3) event_appoint_form_cost,
  round(sum(event_appoint_form)/sum(form_count)*100,3) event_appoint_form_ratio,
  sum(event_appoint_jump_click) event_appoint_jump_click,
  round(sum(charge)/sum(event_appoint_jump_click),3)  event_appoint_jump_click_cost,
  round(sum(event_appoint_jump_click_cost)/sum(form_count)*100,3) event_appoint_jump_click_ratio,
  sum(union_event_pay_purchase_amount_7d) union_event_pay_purchase_amount_7d,
  round(sum(union_event_pay_purchase_amount_7d_roi)/{day_count}*100,3) union_event_pay_purchase_amount_7d_roi,
  sum(event_order_successed) event_order_successed,
  round(sum(ad_photo_played_10s_ratio)/{day_count}*100,3) ad_photo_played_10s_ratio,
  round(sum(charge)/sum(key_action),3) key_action_cost,
  round(sum(charge)/sum(event_add_shopping_cart) ,3) event_add_shopping_cart_cost ,
  round(sum(event_ad_watch_times)/sum(bclick)*100,3) event_ad_watch_times_ratio,
  round(sum(charge)/sum(event_outbound_call),3) event_outbound_call_cost,
  sum(event_outbound_call) event_outbound_call,
  round(sum(action_new_ratio)/{day_count}*100,3) action_new_ratio,
  sum(event_watch_app_ad) event_watch_app_ad,
  round(sum(charge)/sum(event_multi_conversion) ,3) event_multi_conversion_cost,
  sum(event_phone_card_activate) event_phone_card_activate,
  round(sum(ad_photo_played_75percent_ratio)/{day_count}*100,3) ad_photo_played_75percent_ratio,
  round(sum(key_action)/sum(activation)*100,3) key_action_ratio ,
  round(sum(charge)/sum(event_ad_watch_times),3) event_ad_watch_times_cost,
  sum(event_add_shopping_cart) event_add_shopping_cart,
  sum(key_action) key_action,
  sum(event_multi_conversion) event_multi_conversion,
  sum(event_wechat_connected) event_wechat_connected,
  sum(event_dsp_gift_form) event_dsp_gift_form,
  sum(event_intention_confirmed) event_intention_confirmed,
  sum(event_phone_get_through) event_phone_get_through,
  round(sum(event_multi_conversion)/sum(activation)*100,3)  event_multi_conversion_ratio,
  sum(event_measurement_house) event_measurement_house,
  round(sum(ad_photo_played_2s_ratio)/{day_count}*100,3) ad_photo_played_2s_ratio,
  round(sum(event_outbound_call_ratio)/sum(activation)*100,3) event_outbound_call_ratio,
  sum(event_ad_watch_times) event_ad_watch_times
from (
SELECT
report.advertiser_id account_id,
dep.company_id,
CASE
WHEN dep.company_id = 'd57fecdcf7a94d009736d9c850731582' THEN
'北京汇创思拓数字科技有限公司'
WHEN dep.company_id = '6608ed13c0dd42de93c790dbdf124234' THEN
'广州汇创思拓数字科技有限公司'
WHEN dep.company_id = '4b10089775c040119e139087517aed88' THEN
'上海汇创思拓数字科技有限公司'
ELSE
dep.company_name
END company_name,
dep.org_code,
dep.org_type,
dep.dep_id,
dep.dep_name,
dep.user_id,
dep.realname,
dep.leader_id,
dep.leader_name,
report.charge ,
report.`show`,
    report.photo_click,
    report.aclick ,
    report.bclick ,
    report.photo_click_ratio,
    report.play_3s_ratio,
    report.action_ratio ,
    report.impression_1k_cost ,
    report.photo_click_cost,
    report.action_cost,
    report.`share`,
    report.`comment`,
    report.`like`,
    report.follow ,
    report.cancel_follow,
    report.report ,
    report.block,
    report.negative,
    report.submit ,
    report.download_started,
    report.download_completed ,
    report.activation,
    report.event_pay_first_day,
    report.event_pay_purchase_amount_first_day,
    report.event_pay_first_day_roi,
    report.event_pay ,
    report.event_pay_purchase_amount,
    report.event_pay_roi,
    report.event_register,
    report.event_register_cost,
    report.event_register_ratio,
    report.event_jin_jian_app ,
    report.event_jin_jian_app_cost,
    report.event_credit_grant_app,
    report.event_credit_grant_app_cost ,
    report.event_credit_grant_app_ratio,
    report.event_order_paid,
    report.event_order_paid_purchase_amount,
    report.event_order_paid_cost ,
    report.event_next_day_stay,
    report.event_next_day_stay_cost ,
    report.event_next_day_stay_ratio,
    report.form_count,
    report.form_cost ,
    report.form_action_ratio,
    report.event_jin_jian_landing_page ,
    report.event_jin_jian_landing_page_cost,
    report.event_credit_grant_landing_page,
    report.event_credit_grant_landing_page_cost ,
    report.event_credit_grant_landing_page_ratio,
    report.event_valid_clues,
    report.event_valid_clues_cost,
    report.event_add_wechat,
    report.event_add_wechat_cost ,
    report.event_add_wechat_ratio,
    report.event_get_through,
    report.event_get_through_cost,
    report.event_get_through_ratio,
    report.event_app_invoked,
    report.event_app_invoked_cost,
    report.event_app_invoked_ratio,
    report.event_credit_grant_landing_ratio,
    report.play_5s_ratio,
    report.play_end_ratio,
    report.event_new_user_pay ,
    report.event_new_user_pay_cost,
    report.event_new_user_pay_ratio ,
    report.click_1k_cost,
    report.ad_product_cnt,
    report.event_goods_view,
    report.merchant_reco_fans ,
    report.event_order_amount_roi,
    report.event_goods_view_cost ,
    report.merchant_reco_fans_cost,
    report.event_button_click ,
    report.event_button_click_cost,
    report.event_button_click_ratio ,
    report.event_order_paid_roi,
    report.event_new_user_jinjian_app,
    report.event_new_user_jinjian_app_cost,
    report.event_new_user_jinjian_app_roi ,
    report.event_new_user_credit_grant_app,
    report.event_new_user_credit_grant_app_cost ,
    report.event_new_user_credit_grant_app_roi,
    report.event_new_user_jinjian_page ,
    report.event_new_user_jinjian_page_cost,
    report.event_new_user_jinjian_page_roi,
    report.event_new_user_credit_grant_page,
    report.event_new_user_credit_grant_page_cost,
    report.event_new_user_credit_grant_page_roi ,
    report.event_appoint_form ,
    report.event_appoint_form_cost,
    report.event_appoint_form_ratio ,
    report.event_appoint_jump_click ,
    report.event_appoint_jump_click_cost,
    report.event_appoint_jump_click_ratio ,
    report.union_event_pay_purchase_amount_7d,
    report.union_event_pay_purchase_amount_7d_roi,
    report.placement_type,
    report.ad_scene,
    report.event_order_successed ,
    report.ad_photo_played_10s_ratio,
    report.key_action_cost ,
    report.event_add_shopping_cart_cost,
    report.event_ad_watch_times_ratio,
    report.event_outbound_call_cost ,
    report.event_outbound_call,
    report.action_new_ratio,
    report.event_watch_app_ad ,
    report.event_multi_conversion_cost ,
    report.event_phone_card_activate,
    report.ad_photo_played_75percent_ratio,
    report.key_action_ratio,
    report.event_ad_watch_times_cost,
    report.event_add_shopping_cart,
    report.key_action,
    report.event_multi_conversion,
    report.event_wechat_connected,
    report.event_dsp_gift_form,
    report.event_intention_confirmed,
    report.event_phone_get_through,
    report.event_multi_conversion_ratio,
    report.event_measurement_house,
    report.ad_photo_played_2s_ratio ,
    report.event_outbound_call_ratio,
    report.event_ad_watch_times
   from
   (select * from  media_api.kuaishou_account_report_daily  
   where stat_date >= date_format(date_sub({date_time}, INTERVAL {day_count}-1 DAY),'%Y%m%d')) report
   left join
   (
SELECT
cua.account_id,
uc.company_id,
uc.company_name,
pa.org_code,
pa.org_type,
pa.id dep_id,
pa.depart_name dep_name,
cua.user_id,
su.realname,
cp.sale_id,
su.leader_id,
se.realname leader_name
FROM
`jeecg-boot`.ctop_user_allocation cua
LEFT JOIN `jeecg-boot`.ctop_project cp ON cua.project_id = cp.id
LEFT JOIN `jeecg-boot`.user_company uc ON uc.user_id = cua.user_id
LEFT JOIN `jeecg-boot`.sys_user su ON su.id = cua.user_id
LEFT JOIN `jeecg-boot`.sys_user se ON su.leader_id=se.id
LEFT JOIN `jeecg-boot`.sys_user_depart de ON su.leader_id = de.user_id
LEFT JOIN `jeecg-boot`.sys_depart pa ON pa.id = de.dep_id) dep
ON report.advertiser_id = dep.account_id) com
group by
company_id,
org_code,
org_type,
dep_id,
leader_id)new
left join
(select  ifnull(b.leader_id,'-') leader_id ,sum(a.charge) charge from
(select advertiser_id account_id,sum(charge)charge from  media_api.kuaishou_account_report_daily
where stat_date between date_format(date_sub(date_format(date_sub({date_time}, INTERVAL {day_count} DAY),'%Y%m%d'), INTERVAL {day_count}-1 DAY),'%Y%m%d')
and date_format(date_sub({date_time}, INTERVAL {day_count} DAY),'%Y%m%d')
group by advertiser_id) a
left join
(SELECT cua.account_id,su.leader_id
FROM  `jeecg-boot`.ctop_user_allocation cua
LEFT JOIN `jeecg-boot`.ctop_project cp ON cua.project_id = cp.id
LEFT JOIN `jeecg-boot`.sys_user su ON su.id = cua.user_id) b
on  a.account_id=b.account_id
group by b.leader_id) ratio
on new.leader_id=ratio.leader_id;
""".format(date_time=self.date_time, day_count=self.day_count)
            print(sql)
            TidbConn.upsert(conn=self.conn, sql_buff=sql)
            self.conn.commit()
            TidbConn.conn_close(conn=self.conn)
            return 0
        except Exception as e:
            logging.error(e)
            return -1


if __name__ == '__main__':
    status = AppKuaishouCompanyUserReportBusi().taskHandler()
    if status == 0:
        print("作业执行成功")
        exit(0)
    else:
        print("作业执行失败")
        exit(-1)
