# Author renyupeng
# coding=utf-8
# @Time    : 2021/11/10 3:37 下午
# @Site    :
# @File    : AppKuaishouProjectReportBusiMonth.py
# @Software: PyCharm
# @contact: renyupeng@c-top.com.cn
# @Tel 1501435553
import logging
from Apietl.conn.TidbConn import TidbConn
from Apietl.utlis.Utils import Utils


class AppKuaishouProjectReportBusiMonth:
    def __init__(self):
        self.conn = TidbConn.get_connection()
        self.parm = Utils.get_task_args()
        self.date_time = self.parm[0]
        self.day_count = Utils.get_days()

    def taskHandler(self):
        try:
            sql = """
SET sql_mode = 'STRICT_TRANS_TABLES,NO_ZERO_IN_DATE,NO_ZERO_DATE,NO_AUTO_CREATE_USER,NO_ENGINE_SUBSTITUTION';
REPLACE INTO application.app_kuaishou_project_report_busi_m
SELECT
date_format({date_time},'%Y%m') as  stat_mon,
ifnull(uc.company_id,'-') company_id,
CASE WHEN uc.company_id = 'd57fecdcf7a94d009736d9c850731582' THEN '北京汇创思拓数字科技有限公司'
       WHEN uc.company_id = '6608ed13c0dd42de93c790dbdf124234' THEN '广州汇创思拓数字科技有限公司'
       WHEN uc.company_id = '4b10089775c040119e139087517aed88' THEN '上海汇创思拓数字科技有限公司' ELSE uc.company_name END 
       company_name,
 ifnull(cp.product_id,'-') product_id,
 cn.product_name,
 ifnull(cua.project_id,'-') project_id,
 cp.project_name,
 count(report.advertiser_id) account_num,
 sum(charge) charge,
sum(`show`) `show`,
sum(photo_click)photo_click,
sum(aclick)  aclick,
sum(bclick) bclick,
ifnull(round(sum(photo_click)/sum(`show`),3),0) photo_click_ratio,
ifnull(round(sum(play_3s_ratio)/{day_count}*100,3),0)  play_3s_ratio,
ifnull(round(sum(bclick)/sum(aclick)*100,3),0) action_ratio,
ifnull(round(sum(impression_1k_cost)/{day_count},3),0) impression_1k_cost,
ifnull(round(sum(charge)/sum(photo_click),3),0) photo_click_cost,
ifnull(round(sum(charge)/sum(bclick),3),0) action_cost,
sum(`share`) `share`,
sum(`comment`) `comment`,
sum(`like`)  `like`,
sum(follow) follow,
sum(cancel_follow)  cancel_follow,
sum(report) report,
sum(block) block,
sum(negative) negative,
sum(submit) submit,
sum(download_started) download_started,
sum(download_completed) download_completed,
sum(activation) activation,
sum(event_pay_first_day) event_pay_first_day,
sum(event_pay_purchase_amount_first_day) event_pay_purchase_amount_first_day,
ifnull(round(sum(event_pay_purchase_amount_first_day)/sum(charge)*100,3),0) event_pay_first_day_roi ,
sum(event_pay) event_pay,
sum(event_pay_purchase_amount) event_pay_purchase_amount,
ifnull(round(sum(event_pay_purchase_amount)/sum(charge)*100,3),0) event_pay_roi,
sum(event_register) event_register,
ifnull(round(sum(charge)/sum(event_register),3),0) event_register_cost,
ifnull(round(sum(event_register)/sum(activation)*100,3),0) event_register_ratio,
sum(event_jin_jian_app) event_jin_jian_app,
ifnull(round(sum(charge)/sum(event_jin_jian_app),3),0) event_jin_jian_app_cost,
sum(event_credit_grant_app) event_credit_grant_app,
ifnull(round(sum(charge)/sum(event_credit_grant_app),3),0) event_credit_grant_app_cost ,
ifnull(round(sum(event_credit_grant_app_ratio)/{day_count}*100,3),0) event_credit_grant_app_ratio,
sum(event_order_paid) event_order_paid,
sum(event_order_paid_purchase_amount) event_order_paid_purchase_amount,
ifnull(round(sum(event_order_paid_purchase_amount)/sum(event_order_paid) ,3),0) event_order_paid_cost,
sum(event_next_day_stay) event_next_day_stay,
ifnull(round(sum(charge)/sum(event_next_day_stay),3),0) event_next_day_stay_cost,
ifnull(round(sum(event_next_day_stay)/sum(activation)*100,3),0) event_next_day_stay_ratio,
sum(form_count) form_count,
ifnull(round(sum(charge)/sum(form_count),3),0) form_cost,
ifnull(round(sum(form_count)/sum(`bclick`)*100,3),0) form_action_ratio,
sum(event_jin_jian_landing_page) event_jin_jian_landing_page,
ifnull(round(sum(charge)/sum(event_jin_jian_landing_page),3),0) event_jin_jian_landing_page_cost,
sum(event_credit_grant_landing_page) event_credit_grant_landing_page,
ifnull(round(sum(charge)/sum(event_credit_grant_landing_page),3),0) event_credit_grant_landing_page_cost,
ifnull(round(sum(event_credit_grant_landing_page)/{day_count}*100,3),0) event_credit_grant_landing_page_ratio,
sum(event_valid_clues) event_valid_clues,
ifnull(round(sum(charge)/sum(event_valid_clues),3),0) event_valid_clues_cost,
sum(event_add_wechat) event_add_wechat,
ifnull(round(sum(charge)/sum(event_add_wechat),3),0) event_add_wechat_cost,
ifnull(round(sum(event_add_wechat)/sum(bclick)*100,3),0) event_add_wechat_ratio,
sum(event_get_through) event_get_through,
ifnull(round(sum(charge)/sum(event_get_through),3),0) event_get_through_cost,
ifnull(round(sum(event_get_through)/sum(bclick)*100,3),0) event_get_through_ratio,
sum(event_app_invoked) event_app_invoked,
ifnull(round(sum(charge)/sum(event_app_invoked),3),0) event_app_invoked_cost ,
ifnull(round(sum(event_app_invoked)/sum(bclick)*100,3),0) event_app_invoked_ratio,
ifnull(round(sum(event_credit_grant_landing_ratio)/{day_count}*100,3),0) event_credit_grant_landing_ratio,
ifnull(round(sum(play_5s_ratio)/{day_count}*100,3),0) play_5s_ratio,
ifnull(round(sum(play_end_ratio)/{day_count}*100,3),0) play_end_ratio,
sum(event_new_user_pay) event_new_user_pay,
ifnull(round(sum(charge)/sum(event_new_user_pay),3),0) event_new_user_pay_cost,
ifnull(round(sum(event_new_user_pay)/sum(activation)*100,3),0) event_new_user_pay_ratio,
ifnull(round(sum(click_1k_cost)/{day_count}*100,3),0) click_1k_cost,
sum(ad_product_cnt) ad_product_cnt,
sum(event_goods_view) event_goods_view,
sum(merchant_reco_fans) merchant_reco_fans,
ifnull(round(sum(event_order_amount_roi)/{day_count}*100,3),0) event_order_amount_roi,
ifnull(round(sum(charge)/sum(event_goods_view) ,3),0) event_goods_view_cost,
ifnull(round(sum(charge)/sum(merchant_reco_fans),3),0) merchant_reco_fans_cost,
sum(event_button_click) event_button_click,
ifnull(round(sum(charge)/sum(event_button_click),3),0) event_button_click_cost,
ifnull(round(sum(event_button_click)/sum(bclick)*100,3),0) event_button_click_ratio ,
ifnull(round(sum(event_order_paid_roi)/{day_count}*100,3),0) event_order_paid_roi,
sum(event_new_user_jinjian_app) event_new_user_jinjian_app,
ifnull(round(sum(charge)/sum(event_new_user_jinjian_app),3),0) event_new_user_jinjian_app_cost,
ifnull(round(sum(event_new_user_jinjian_app)/sum(form_count)*100,3),0) event_new_user_jinjian_app_roi ,
sum(event_new_user_credit_grant_app) event_new_user_credit_grant_app,
ifnull(round(sum(charge)/sum(event_new_user_credit_grant_app),3),0)  event_new_user_credit_grant_app_cost,
ifnull(round(sum(event_new_user_credit_grant_app)/sum(form_count)*100,3),0) event_new_user_credit_grant_app_roi,
sum(event_new_user_jinjian_page) event_new_user_jinjian_page,
ifnull(round(sum(charge)/sum(event_new_user_jinjian_page),3),0) event_new_user_jinjian_page_cost,
ifnull(round(sum(event_new_user_jinjian_page)/sum(form_count)*100,3),0) event_new_user_jinjian_page_roi ,
sum(event_new_user_credit_grant_page) event_new_user_credit_grant_page,
ifnull(round(sum(charge)/sum(event_new_user_credit_grant_page) ,3),0) event_new_user_credit_grant_page_cost,
ifnull(round(sum(event_new_user_credit_grant_page)/sum(form_count)*100,3),0) event_new_user_credit_grant_page_roi,
sum(event_appoint_form)  event_appoint_form,
ifnull(round(sum(charge)/sum(event_appoint_form),3),0) event_appoint_form_cost,
ifnull(round(sum(event_appoint_form)/sum(form_count)*100,3),0) event_appoint_form_ratio,
sum(event_appoint_jump_click) event_appoint_jump_click,
ifnull(round(sum(charge)/sum(event_appoint_jump_click),3),0)  event_appoint_jump_click_cost,
ifnull(round(sum(event_appoint_jump_click_cost)/sum(form_count)*100,3),0) event_appoint_jump_click_ratio,
sum(union_event_pay_purchase_amount_7d) union_event_pay_purchase_amount_7d,
ifnull(round(sum(union_event_pay_purchase_amount_7d_roi)/{day_count}*100,3),0) union_event_pay_purchase_amount_7d_roi,
sum(event_order_successed) event_order_successed,
ifnull(round(sum(ad_photo_played_10s_ratio)/{day_count}*100,3),0) ad_photo_played_10s_ratio,
ifnull(round(sum(charge)/sum(key_action),3),0) key_action_cost,
ifnull(round(sum(charge)/sum(event_add_shopping_cart) ,3),0) event_add_shopping_cart_cost ,
ifnull(round(sum(event_ad_watch_times)/sum(bclick)*100,3),0) event_ad_watch_times_ratio,
ifnull(round(sum(charge)/sum(event_outbound_call),3),0) event_outbound_call_cost,
sum(event_outbound_call) event_outbound_call,
ifnull(round(sum(action_new_ratio)/{day_count}*100,3),0) action_new_ratio,
sum(event_watch_app_ad) event_watch_app_ad,
ifnull(round(sum(charge)/sum(event_multi_conversion) ,3),0) event_multi_conversion_cost,
sum(event_phone_card_activate) event_phone_card_activate,
ifnull(round(sum(ad_photo_played_75percent_ratio)/{day_count}*100,3),0) ad_photo_played_75percent_ratio,
ifnull(round(sum(key_action)/sum(activation)*100,3),0) key_action_ratio ,
ifnull(round(sum(charge)/sum(event_ad_watch_times),3),0) event_ad_watch_times_cost,
sum(event_add_shopping_cart) event_add_shopping_cart,
sum(key_action) key_action,
sum(event_multi_conversion) event_multi_conversion,
sum(event_wechat_connected) event_wechat_connected,
sum(event_dsp_gift_form) event_dsp_gift_form,
sum(event_intention_confirmed) event_intention_confirmed,
sum(event_phone_get_through) event_phone_get_through,
ifnull(round(sum(event_multi_conversion)/sum(activation)*100,3),0)  event_multi_conversion_ratio,
sum(event_measurement_house) event_measurement_house,
ifnull(round(sum(ad_photo_played_2s_ratio)/{day_count}*100,3),0) ad_photo_played_2s_ratio,
ifnull(round(sum(event_outbound_call_ratio)/sum(activation)*100,3),0) event_outbound_call_ratio,
sum(event_ad_watch_times) event_ad_watch_times
 from  
 (select * from  media_api.kuaishou_account_report_daily  
 where stat_date >= date_format(date_sub({date_time}, INTERVAL {day_count} DAY),'%Y%m%d')
 ) report
LEFT JOIN `jeecg-boot`.ctop_user_allocation cua ON report.advertiser_id = cua.account_id
LEFT JOIN `jeecg-boot`.ctop_project cp ON cua.project_id = cp.id
LEFT JOIN `jeecg-boot`.ctop_product cn ON cp.product_id = cn.id
LEFT JOIN `jeecg-boot`.user_company uc ON uc.user_id = cua.user_id
GROUP BY
cua.project_id;
 
            """.format(date_time=self.date_time, day_count=self.day_count)
            TidbConn.upsert(conn=self.conn, sql_buff=sql)
            self.conn.commit()
            TidbConn.conn_close(conn=self.conn)
            return 0
        except Exception as e:
            logging.error(e)
            return -1


if __name__ == '__main__':
    status = AppKuaishouProjectReportBusiMonth().taskHandler()
    if status == 0:
        print("作业执行成功")
        exit(0)
    else:
        print("作业执行失败")
        exit(-1)
