#!/usr/bin/env python3
# coding:utf-8
"""
logging配置
"""
import os
import time
import logging.config
import sys
from Apietl.constant.ConfConstant import ConfConstant


class Logger:

    def GetLocalTime(self):
        # 获取当前时间
        time_now = int(time.time())
        # 转换成localtime
        time_local = time.localtime(time_now)
        # 转换成新的时间格式(2016-05-09 18:59:20)
        dt = time.strftime("%Y%m%d", time_local)

        return dt

    def etl_logger(self, media, dt):

        # 定义三种日志输出格式 开始
        standard_format = '[%(asctime)s][%(threadName)s:%(thread)d][task_id:%(name)s][%(filename)s:%(lineno)d]' \
                          '[%(levelname)s][%(message)s]'  # 其中name为getlogger指定的名字

        simple_format = '[%(levelname)s][%(asctime)s][%(filename)s:%(lineno)d]%(message)s'

        id_simple_format = '[%(levelname)s][%(asctime)s] %(message)s'

        # 定义日志输出格式 结束
        argv0_list = sys.argv[0].split("/")
        script_name = argv0_list[len(argv0_list) - 1]
        scname = script_name[0:-3]  # 获取执行程序文件名
        # home = os.getenv('ARK_HOME')
        # log_home = os.path.join(home, 'logs')
        log_home = ConfConstant.Log_home
        logfile_dir = os.path.dirname('{}/{}/{}'.format(log_home, self.GetLocalTime(), media))

        logfile_name = '{0}_{1}.log'.format(scname, dt)  # log文件名

        # 如果不存在定义的日志目录就创建一个
        if not os.path.isdir(logfile_dir):
            os.makedirs(logfile_dir)

        # log文件的全路径
        logfile_path = os.path.join(logfile_dir, logfile_name)

        # log配置字典
        LOGGING_DIC = {
            'version': 1,
            'disable_existing_loggers': False,
            'formatters': {
                'standard': {
                    'format': standard_format
                },
                'simple': {
                    'format': simple_format
                },
                'id_simple': {
                    'format': id_simple_format
                },
            },
            'filters': {},
            'handlers': {
                # 打印到终端的日志
                'console': {
                    'level': 'INFO',
                    'class': 'logging.StreamHandler',  # 打印到屏幕
                    'formatter': 'id_simple'
                },
                # 打印到文件的日志,收集info及以上的日志
                'default': {
                    'level': 'INFO',
                    'class': 'logging.handlers.RotatingFileHandler',  # 保存到文件
                    'formatter': 'id_simple',
                    'filename': logfile_path,  # 日志文件
                    # 'maxBytes': 1024*1024*5,  # 日志大小 5M
                    'backupCount': 5,
                    'encoding': 'utf-8',  # 日志文件的编码，再也不用担心中文log乱码了
                },
            },
            'loggers': {
                # logging.getLogger(__name__)拿到的logger配置
                '': {
                    'handlers': ['default', 'console'],  # 这里把上面定义的两个handler都加上，即log数据既写入文件又打印到屏幕
                    'level': 'INFO',
                    'propagate': True,  # 向上（更高level的logger）传递
                },
            },
        }

        logging.config.dictConfig(LOGGING_DIC)  # 导入上面定义的logging配置

        return logging.getLogger(__name__)  # 生成一个log实例

    def inilg(self, uname):
        # 定义三种日志输出格式 开始
        dt = self.GetLocalTime()
        standard_format = '[%(asctime)s][%(threadName)s:%(thread)d][task_id:%(name)s][%(filename)s:%(lineno)d]' \
                          '[%(levelname)s][%(message)s]'  # 其中name为getlogger指定的名字

        simple_format = '[%(levelname)s][%(asctime)s][%(filename)s:%(lineno)d]%(message)s'

        id_simple_format = '[%(levelname)s][%(asctime)s] %(message)s'

        # 定义日志输出格式 结束
        # '/data/api/logs/gdt/mly/log'
        # logfile_dir = os.path.dirname('{0}/{1}'.format(os.path.abspath(__file__), 'logs'))  # log文件的目录
        logfile_dir = Constant.Log_home + "/hload"  # log文件的目录

        logfile_name = '{}{}.log'.format(uname, dt)  # log文件名

        # 如果不存在定义的日志目录就创建一个
        if not os.path.isdir(logfile_dir):
            os.mkdir(logfile_dir)

        # log文件的全路径
        logfile_path = os.path.join(logfile_dir, logfile_name)

        # log配置字典
        LOGGING_DIC = {
            'version': 1,
            'disable_existing_loggers': False,
            'formatters': {
                'standard': {
                    'format': standard_format
                },
                'simple': {
                    'format': simple_format
                },
            },
            'filters': {},
            'handlers': {
                # 打印到终端的日志
                'console': {
                    'level': 'DEBUG',
                    'class': 'logging.StreamHandler',  # 打印到屏幕
                    'formatter': 'simple'
                },
                # 打印到文件的日志,收集info及以上的日志
                'default': {
                    'level': 'INFO',
                    'class': 'logging.handlers.RotatingFileHandler',  # 保存到文件
                    'formatter': 'standard',
                    'filename': logfile_path,  # 日志文件
                    # 'maxBytes': 1024*1024*5,  # 日志大小 5M
                    'backupCount': 5,
                    'encoding': 'utf-8',  # 日志文件的编码，再也不用担心中文log乱码了
                },
            },
            'loggers': {
                # logging.getLogger(__name__)拿到的logger配置
                '': {
                    'handlers': ['default', 'console'],  # 这里把上面定义的两个handler都加上，即log数据既写入文件又打印到屏幕
                    'level': 'DEBUG',
                    'propagate': True,  # 向上（更高level的logger）传递
                },
            },
        }
        logging.config.dictConfig(LOGGING_DIC)  # 导入上面定义的logging配置
        logger = logging.getLogger(__name__)  # 生成一个log实例
        try:
            logger.debug('ok')  # 记录该文件的运行状态
            pass
        except Exception as e:
            logger.error(e)
